## cmark-gfm 0.28.3.gfm.17

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.9)

# prevent ugly developer warnings because version is set directly, not through project()
# it should be redone properly by using VERSION in project() if on CMake 3.x
if(CMAKE_MAJOR_VERSION GREATER 2)
    cmake_policy(SET CMP0048 OLD)
endif()

project(cmark-gfm)

include("FindAsan.cmake")

if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
    message(FATAL_ERROR "Do not build in-source.\nPlease remove CMakeCache.txt and the CMakeFiles/ directory.\nThen: mkdir build ; cd build ; cmake .. ; make")
endif()

set(PROJECT_NAME "cmark-gfm")

set(PROJECT_VERSION_MAJOR 0)
set(PROJECT_VERSION_MINOR 28)
set(PROJECT_VERSION_PATCH 3)
set(PROJECT_VERSION_GFM 17)
set(PROJECT_VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}.gfm.${PROJECT_VERSION_GFM} )

option(CMARK_TESTS "Build cmark-gfm tests and enable testing" ON)
option(CMARK_STATIC "Build static libcmark-gfm library" ON)
option(CMARK_SHARED "Build shared libcmark-gfm library" ON)
option(CMARK_LIB_FUZZER "Build libFuzzer fuzzing harness" OFF)

add_subdirectory(src)
add_subdirectory(extensions)
if(CMARK_TESTS AND (CMARK_SHARED OR CMARK_STATIC))
  add_subdirectory(api_test)
endif()
add_subdirectory(man)
if(CMARK_TESTS)
  enable_testing()
  add_subdirectory(test testdir)
endif()

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING
  "Choose the type of build, options are: Debug Profile Release Asan Ubsan." FORCE)
endif(NOT CMAKE_BUILD_TYPE)

=== debian/changelog ===
cmark-gfm (0.28.3.gfm.17-1) unstable; urgency=medium

  * Initial release. (Closes: #894271)

 -- Keith Packard <keithp@keithp.com>  Mon, 08 Oct 2018 11:08:01 -0700

=== debian/control ===
Source: cmark-gfm
Section: text
Priority: optional
Homepage: https://github.com/github/cmark
Maintainer: Keith Packard <keithp@keithp.com>
Build-Depends: debhelper (>= 11), cmake, python3
Standards-Version: 4.2.1

Package: cmark-gfm
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: CommonMark parsing and rendering program, GitHub flavor
 cmark-gfm is the GitHub flavor of the cmark C reference
 implementation of CommonMark, a rationalized version of Markdown
 syntax with a spec.  This package provides a command-line program
 (cmark-gfm) for parsing and rendering CommonMark documents.
 .
 This GitHub flavored version has extensions for org-mode style
 tables, auto-linking, and more.

Package: libcmark-gfm0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: CommonMark GitHub flavor gfm library
 cmark-gfm is the GitHub flavor of the cmark C reference
 implementation of CommonMark, a rationalized version of Markdown
 syntax with a spec. This package provides the required gfm
 library

Package: libcmark-gfm-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}
Description: CommonMark GitHub flavor gfm library dev files
 cmark-gfm is the GitHub flavor of the cmark C reference
 implementation of CommonMark, a rationalized version of Markdown
 syntax with a spec. This package provides the development files for
 the gfm library

Package: libcmark-gfm-extensions0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: CommonMark GitHub flavor gfm extension library
 cmark-gfm is the GitHub flavor of the cmark C reference
 implementation of CommonMark, a rationalized version of Markdown
 syntax with a spec. This package provides the required gfm extension
 library

Package: libcmark-gfm-extensions-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}
Description: CommonMark GitHub flavor gfm extensions library dev files
 cmark-gfm is the GitHub flavor of the cmark C reference
 implementation of CommonMark, a rationalized version of Markdown
 syntax with a spec. This package provides the development files for
 the gfm extensions library

## cmark-gfm 0.28.3.gfm.19

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,7 @@
 set(PROJECT_VERSION_MAJOR 0)
 set(PROJECT_VERSION_MINOR 28)
 set(PROJECT_VERSION_PATCH 3)
-set(PROJECT_VERSION_GFM 17)
+set(PROJECT_VERSION_GFM 19)
 set(PROJECT_VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}.gfm.${PROJECT_VERSION_GFM} )
 
 option(CMARK_TESTS "Build cmark-gfm tests and enable testing" ON)

=== Makefile ===
SRCDIR=src
EXTDIR=extensions
DATADIR=data
BUILDDIR?=build
GENERATOR?=Unix Makefiles
MINGW_BUILDDIR?=build-mingw
MINGW_INSTALLDIR?=windows
SPEC=test/spec.txt
EXTENSIONS_SPEC=test/extensions.txt
SITE=_site
SPECVERSION=$(shell perl -ne 'print $$1 if /^version: *([0-9.]+)/' $(SPEC))
FUZZCHARS?=2000000  # for fuzztest
BENCHDIR=bench
BENCHSAMPLES=$(wildcard $(BENCHDIR)/samples/*.md)
BENCHFILE=$(BENCHDIR)/benchinput.md
ALLTESTS=alltests.md
NUMRUNS?=20
CMARK=$(BUILDDIR)/src/cmark-gfm
CMARK_FUZZ=$(BUILDDIR)/src/cmark-fuzz
PROG?=$(CMARK)
VERSION?=$(SPECVERSION)
RELEASE?=CommonMark-$(VERSION)
INSTALL_PREFIX?=/usr/local
CLANG_CHECK?=clang-check
CLANG_FORMAT=clang-format-3.5 -style llvm -sort-includes=0 -i
AFL_PATH?=/usr/local/bin

.PHONY: all cmake_build leakcheck clean fuzztest test debug ubsan asan mingw archive newbench bench format update-spec afl clang-check docker libFuzzer

all: cmake_build man/man3/cmark-gfm.3

$(CMARK): cmake_build

cmake_build: $(BUILDDIR)
	@$(MAKE) -j2 -C $(BUILDDIR)
	@echo "Binaries can be found in $(BUILDDIR)/src"

$(BUILDDIR):
	@cmake --version > /dev/null || (echo "You need cmake to build this program: http://www.cmake.org/download/" && exit 1)
	mkdir -p $(BUILDDIR); \
	cd $(BUILDDIR); \
	cmake .. \
		-G "$(GENERATOR)" \
		-DCMAKE_BUILD_TYPE=$(BUILD_TYPE) \
		-DCMAKE_INSTALL_PREFIX=$(INSTALL_PREFIX) \
		-DCMAKE_EXPORT_COMPILE_COMMANDS=ON

install: $(BUILDDIR)
	$(MAKE) -C $(BUILDDIR) install

debug:
	mkdir -p $(BUILDDIR); \
	cd $(BUILDDIR); \
	cmake .. -DCMAKE_BUILD_TYPE=Debug; \
	$(MAKE)

ubsan:
	mkdir -p $(BUILDDIR); \
	cd $(BUILDDIR); \
	cmake .. -DCMAKE_BUILD_TYPE=Ubsan; \
	$(MAKE)

asan:
	mkdir -p $(BUILDDIR); \
	cd $(BUILDDIR); \
	cmake .. -DCMAKE_BUILD_TYPE=Asan; \
	$(MAKE)

prof:
	mkdir -p $(BUILDDIR); \
	cd $(BUILDDIR); \
	cmake .. -DCMAKE_BUILD_TYPE=Profile; \
	$(MAKE)

afl:
	@[ -n "$(AFL_PATH)" ] || { echo '$$AFL_PATH not set'; false; }
	mkdir -p $(BUILDDIR)
	cd $(BUILDDIR) && cmake .. -DCMAKE_C_COMPILER=$(AFL_PATH)/afl-clang
	$(MAKE)
	$(AFL_PATH)/afl-fuzz \
	    -i test/afl_test_cases \
	    -o test/afl_results \
	    -x test/fuzzing_dictionary \
	    $(AFL_OPTIONS) \
	    -t 100 \
	    $(CMARK) -e table -e strikethrough -e autolink -e tagfilter $(CMARK_OPTS)

libFuzzer:
	@[ -n "$(LIB_FUZZER_PATH)" ] || { echo '$$LIB_FUZZER_PATH not set'; false; }
	mkdir -p $(BUILDDIR)
	cd $(BUILDDIR) && cmake -DCMAKE_BUILD_TYPE=Asan -DCMARK_LIB_FUZZER=ON -DCMAKE_LIB_FUZZER_PATH=$(LIB_FUZZER_PATH) ..
	$(MAKE) -j2 -C $(BUILDDIR) cmark-fuzz
	test/run-cmark-fuzz $(CMARK_FUZZ)

clang-check: all
	${CLANG_CHECK} -p build -analyze src/*.c

mingw:
	mkdir -p $(MINGW_BUILDDIR); \
	cd $(MINGW_BUILDDIR); \
	cmake .. -DCMAKE_TOOLCHAIN_FILE=../toolchain-mingw32.cmake -DCMAKE_INSTALL_PREFIX=$(MINGW_INSTALLDIR) ;\
	$(MAKE) && $(MAKE) install

man/man3/cmark-gfm.3: src/cmark-gfm.h | $(CMARK)
	python man/make_man_page.py $< > $@ \

archive:
	git archive --prefix=$(RELEASE)/ -o $(RELEASE).tar.gz HEAD
	git archive --prefix=$(RELEASE)/ -o $(RELEASE).zip HEAD

clean:
	rm -rf $(BUILDDIR) $(MINGW_BUILDDIR) $(MINGW_INSTALLDIR)

# We include case_fold_switch.inc in the repository, so this shouldn't
# normally need to be generated.
$(SRCDIR)/case_fold_switch.inc: $(DATADIR)/CaseFolding.txt
	perl tools/mkcasefold.pl < $< > $@

# We include scanners.c in the repository, so this shouldn't
# normally need to be generated.
$(SRCDIR)/scanners.c: $(SRCDIR)/scanners.re
	@case "$$(re2c -v)" in \
	    *\ 0.13.*|*\ 0.14|*\ 0.14.1) \
		echo "re2c >= 0.14.2 is required"; \
		false; \
		;; \
	esac
	re2c -W -Werror --case-insensitive -b -i --no-generation-date -8 \
		--encoding-policy substitute -o $@ $<
	$(CLANG_FORMAT) $@

# We include scanners.c in the repository, so this shouldn't
# normally need to be generated.
$(EXTDIR)/ext_scanners.c: $(EXTDIR)/ext_scanners.re
	@case "$$(re2c -v)" in \
	    *\ 0.13.*|*\ 0.14|*\ 0.14.1) \
		echo "re2c >= 0.14.2 is required"; \
		false; \
		;; \
	esac
	re2c --case-insensitive -b -i --no-generation-date -8 \
		--encoding-policy substitute -o $@ $<
	clang-format-3.5 -style llvm -i $@

# We include entities.inc in the repository, so normally this
# doesn't need to be regenerated:
$(SRCDIR)/entities.inc: tools/make_entities_inc.py
	python3 $< > $@

update-spec:
	curl 'https://raw.githubusercontent.com/jgm/CommonMark/master/spec.txt'\
 > $(SPEC)

test: $(SPEC) cmake_build
	$(MAKE) -C $(BUILDDIR) test || (cat $(BUILDDIR)/Testing/Temporary/LastTest.log && exit 1)

$(ALLTESTS): $(SPEC) $(EXTENSIONS_SPEC)
	( \
	  python3 test/spec_tests.py --spec $(SPEC) --dump-tests | \
	    python3 -c 'import json; import sys; tests = json.loads(sys.stdin.read()); u8s = open(1, "w", encoding="utf-8", closefd=False); print("\n".join([test["markdown"] for test in tests]), file=u8s)'; \
	  python3 test/spec_tests.py --spec $(EXTENSIONS_SPEC) --dump-tests | \
	    python3 -c 'import json; import sys; tests = json.loads(sys.stdin.read()); u8s = open(1, "w", encoding="utf-8", closefd=False); print("\n".join([test["markdown"] for test in tests]), file=u8s)'; \
	) > $@

leakcheck: $(ALLTESTS)
	for format in html man xml latex commonmark; do \
	  for opts in "" "--smart"; do \
	     echo "cmark-gfm -t $$format -e table -e strikethrough -e autolink -e tagfilter $$opts" ; \
	     valgrind -q --leak-check=full --dsymutil=yes --suppressions=suppressions --error-exitcode=1 $(PROG) -t $$format -e table -e strikethrough -e autolink -e tagfilter $$opts $(ALLTESTS) >/dev/null || exit 1;\
          done; \
	done;

fuzztest:
	{ for i in `seq 1 10`; do \
	  cat /dev/urandom | head -c $(FUZZCHARS) | iconv -f latin1 -t utf-8 | tee fuzz-$$i.txt | \
		/usr/bin/env time -p $(PROG) >/dev/null && rm fuzz-$$i.txt ; \
	done } 2>&1 | grep 'user\|abnormally'

progit:
	git clone https://github.com/progit/progit.git

$(BENCHFILE): progit
	echo "" > $@
	for lang in ar az be ca cs de en eo es es-ni fa fi fr hi hu id it ja ko mk nl no-nb pl pt-br ro ru sr th tr uk vi zh zh-tw; do \
		for i in `seq 1 10`; do \
			cat progit/$$lang/*/*.markdown >> $@; \
		done; \
	done

# for more accurate results, run with
# sudo renice -10 $$; make bench
bench: $(BENCHFILE)
	{ for x in `seq 1 $(NUMRUNS)` ; do \
		/usr/bin/env time -p $(PROG) </dev/null >/dev/null ; \
		/usr/bin/env time -p $(PROG) $< >/dev/null ; \
		done \
	} 2>&1  | grep 'real' | awk '{print $$2}' | python3 'bench/stats.py'

newbench:
	for f in $(BENCHSAMPLES) ; do \
	  printf "%26s  " `basename $$f` ; \
	  { for x in `seq 1 $(NUMRUNS)` ; do \
		/usr/bin/env time -p $(PROG) </dev/null >/dev/null ; \
		for x in `seq 1 200` ; do cat $$f ; done | \
		  /usr/bin/env time -p $(PROG) > /dev/null; \
		done \
	  } 2>&1  | grep 'real' | awk '{print $$2}' | \
	    python3 'bench/stats.py'; done

format:
	$(CLANG_FORMAT) src/*.c src/*.h api_test/*.c api_test/*.h

format-extensions:
	clang-format-3.5 -style llvm -i extensions/*.c extensions/*.h

operf: $(CMARK)
	operf $< < $(BENCHFILE) > /dev/null

distclean: clean
	-rm -rf *.dSYM
	-rm -f README.html
	-rm -rf $(BENCHFILE) $(ALLTESTS) progit

docker:
	docker build -t cmark-gfm $(CURDIR)/tools
	docker run --privileged -t -i -v $(CURDIR):/src/cmark-gfm -w /src/cmark-gfm cmark-gfm /bin/bash

=== api_test/CMakeLists.txt ===
add_executable(api_test
  cplusplus.cpp
  harness.c
  harness.h
  main.c
)
include_directories(
  ${PROJECT_SOURCE_DIR}/src
  ${PROJECT_BINARY_DIR}/src
  ${PROJECT_BINARY_DIR}/extensions
)
if(CMARK_SHARED)
  target_link_libraries(api_test libcmark-gfm-extensions libcmark-gfm)
else()
  target_link_libraries(api_test libcmark-gfm-extensions_static libcmark-gfm_static)
endif()

# Compiler flags
if(MSVC)
  # Force to always compile with W4
  if(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
    string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_C_FLAGS "${CMAKE_C_FLAGS}")
  else()
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /W4")
  endif()
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /wd4706 /D_CRT_SECURE_NO_WARNINGS")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /TP")
elseif(CMAKE_COMPILER_IS_GNUCC OR "${CMAKE_C_COMPILER_ID}" STREQUAL "Clang")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -std=c99 -pedantic -D_BSD_SOURCE -D_POSIX_SOURCE")
endif()

=== extensions/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
set(LIBRARY "libcmark-gfm-extensions")
set(STATICLIBRARY "libcmark-gfm-extensions_static")
set(LIBRARY_SOURCES
    core-extensions.c
    table.c
    strikethrough.c
    autolink.c
    tagfilter.c
    ext_scanners.c
    ext_scanners.re
    ext_scanners.h
   )

include_directories(
  ${PROJECT_SOURCE_DIR}/src
  ${PROJECT_BINARY_DIR}/src
)

include (GenerateExportHeader)

include_directories(. ${CMAKE_CURRENT_BINARY_DIR})

set(CMAKE_C_FLAGS_PROFILE "${CMAKE_C_FLAGS_RELEASE} -pg")
set(CMAKE_LINKER_PROFILE "${CMAKE_LINKER_FLAGS_RELEASE} -pg")
add_compiler_export_flags()

if (CMARK_SHARED)
  add_library(${LIBRARY} SHARED ${LIBRARY_SOURCES})

  set_target_properties(${LIBRARY} PROPERTIES
    OUTPUT_NAME "cmark-gfm-extensions"
    SOVERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}.gfm.${PROJECT_VERSION_GFM}
    VERSION ${PROJECT_VERSION})

  set_property(TARGET ${LIBRARY}
    APPEND PROPERTY MACOSX_RPATH true)

  # Avoid name clash between PROGRAM and LIBRARY pdb files.
  set_target_properties(${LIBRARY} PROPERTIES PDB_NAME cmark-gfm-extensions_dll)

  generate_export_header(${LIBRARY}
    BASE_NAME cmark-gfm-extensions)

  list(APPEND CMARK_INSTALL ${LIBRARY})
  target_link_libraries(${LIBRARY} libcmark-gfm)

endif()

if (CMARK_STATIC)
  add_library(${STATICLIBRARY} STATIC ${LIBRARY_SOURCES})

  set_target_properties(${STATICLIBRARY} PROPERTIES
    COMPILE_FLAGS "-DCMARK_STATIC_DEFINE -DCMARKEXTENSIONS_STATIC_DEFINE"
    POSITION_INDEPENDENT_CODE ON)

  if (MSVC)
    set_target_properties(${STATICLIBRARY} PROPERTIES
      OUTPUT_NAME "cmark-gfm-extensions_static"
      VERSION ${PROJECT_VERSION})
  else()
    set_target_properties(${STATICLIBRARY} PROPERTIES
      OUTPUT_NAME "cmark-gfm-extensions"
      VERSION ${PROJECT_VERSION})
  endif(MSVC)

  if (NOT CMARK_SHARED)
    generate_export_header(${STATICLIBRARY}
      BASE_NAME cmark-gfm-extensions)
  endif()

  list(APPEND CMARK_INSTALL ${STATICLIBRARY})
endif()

set(CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS_NO_WARNINGS ON)

include (InstallRequiredSystemLibraries)
install(TARGETS ${CMARK_INSTALL}
  EXPORT cmark-gfm-extensions
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib${LIB_SUFFIX}
  ARCHIVE DESTINATION lib${LIB_SUFFIX}
  )

if (CMARK_SHARED OR CMARK_STATIC)
  install(FILES
  cmark-gfm-core-extensions.h
  ${CMAKE_CURRENT_BINARY_DIR}/cmark-gfm-extensions_export.h
  DESTINATION include
  )

  install(EXPORT cmark-gfm-extensions DESTINATION lib${LIB_SUFFIX}/cmake-gfm-extensions)
endif()

# Feature tests
include(CheckIncludeFile)
include(CheckCSourceCompiles)
include(CheckCSourceRuns)
include(CheckSymbolExists)
CHECK_INCLUDE_FILE(stdbool.h HAVE_STDBOOL_H)
CHECK_C_SOURCE_COMPILES(
  "int main() { __builtin_expect(0,0); return 0; }"
  HAVE___BUILTIN_EXPECT)
CHECK_C_SOURCE_COMPILES("
  int f(void) __attribute__ (());
  int main() { return 0; }
" HAVE___ATTRIBUTE__)

# Always compile with warnings
if(MSVC)
  # Force to always compile with W4
  if(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
    string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_C_FLAGS "${CMAKE_C_FLAGS}")
  else()
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /W4")
  endif()
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /WX /wd4706 /wd4204 /wd4221 /wd4100 /D_CRT_SECURE_NO_WARNINGS")
elseif(CMAKE_COMPILER_IS_GNUCC OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Wno-unused-parameter -std=c99 -pedantic")
endif()

# Compile as C++ under MSVC older than 12.0
if(MSVC AND MSVC_VERSION LESS 1800)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /TP")
endif()

if(CMAKE_BUILD_TYPE STREQUAL "Ubsan")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=undefined")
endif()

=== src/CMakeLists.txt ===
if(${CMAKE_VERSION} VERSION_GREATER "3.3")
    cmake_policy(SET CMP0063 NEW)
endif()

include(GNUInstallDirs)

set(LIBRARY "libcmark-gfm")
set(STATICLIBRARY "libcmark-gfm_static")
set(HEADERS
  cmark-gfm.h
  cmark-gfm-extension_api.h
  parser.h
  buffer.h
  node.h
  iterator.h
  chunk.h
  references.h
  footnotes.h
  map.h
  utf8.h
  scanners.h
  inlines.h
  houdini.h
  cmark_ctype.h
  render.h
  registry.h
  syntax_extension.h
  plugin.h
  )
set(LIBRARY_SOURCES
  cmark.c
  node.c
  iterator.c
  blocks.c
  inlines.c
  scanners.c
  scanners.re
  utf8.c
  buffer.c
  references.c
  footnotes.c
  map.c
  render.c
  man.c
  xml.c
  html.c
  commonmark.c
  plaintext.c
  latex.c
  houdini_href_e.c
  houdini_html_e.c
  houdini_html_u.c
  cmark_ctype.c
  arena.c
  linked_list.c
  syntax_extension.c
  registry.c
  plugin.c
  ${HEADERS}
  )

set(PROGRAM "cmark-gfm")
set(PROGRAM_SOURCES
  main.c
  )

include_directories(. ${CMAKE_CURRENT_BINARY_DIR})
include_directories(
  ${PROJECT_BINARY_DIR}/extensions
)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmark-gfm_version.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/cmark-gfm_version.h)

include (GenerateExportHeader)

add_executable(${PROGRAM} ${PROGRAM_SOURCES})
add_compiler_export_flags()

if(CMARK_SHARED)
  target_link_libraries(${PROGRAM} libcmark-gfm-extensions libcmark-gfm)
elseif(CMARK_STATIC)
  target_link_libraries(${PROGRAM} libcmark-gfm-extensions_static libcmark-gfm_static)
endif()

# Disable the PUBLIC declarations when compiling the executable:
set_target_properties(${PROGRAM} PROPERTIES
  COMPILE_FLAGS "-DCMARK_STATIC_DEFINE -DCMARKEXTENSIONS_STATIC_DEFINE")

# Check integrity of node structure when compiled as debug:
set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -DCMARK_DEBUG_NODES -DDEBUG")
set(CMAKE_LINKER_DEBUG "${CMAKE_LINKER_FLAGS_DEBUG}")

set(CMAKE_C_FLAGS_PROFILE "${CMAKE_C_FLAGS_RELEASE} -pg")
set(CMAKE_LINKER_PROFILE "${CMAKE_LINKER_FLAGS_RELEASE} -pg")

add_definitions(-DLIBDIR=\"${CMAKE_BINARY_DIR}\")

if (${CMAKE_VERSION} VERSION_GREATER "1.8")
  set(CMAKE_C_VISIBILITY_PRESET hidden)
  set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)
elseif(CMAKE_COMPILER_IS_GNUCC OR ${CMAKE_C_COMPILER_ID} STREQUAL "Clang")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")
endif ()

if (CMARK_SHARED)
  add_library(${LIBRARY} SHARED ${LIBRARY_SOURCES})
  # Include minor version and patch level in soname for now.
  set_target_properties(${LIBRARY} PROPERTIES
    OUTPUT_NAME "cmark-gfm"
    SOVERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}.gfm.${PROJECT_VERSION_GFM}
    VERSION ${PROJECT_VERSION})

  set_property(TARGET ${LIBRARY}
    APPEND PROPERTY MACOSX_RPATH true)

  # Avoid name clash between PROGRAM and LIBRARY pdb files.
  set_target_properties(${LIBRARY} PROPERTIES PDB_NAME cmark-gfm_dll)

  generate_export_header(${LIBRARY}
    BASE_NAME ${PROJECT_NAME})

  list(APPEND CMARK_INSTALL ${LIBRARY})
endif()

if (CMARK_STATIC)
  add_library(${STATICLIBRARY} STATIC ${LIBRARY_SOURCES})
  set_target_properties(${STATICLIBRARY} PROPERTIES
    COMPILE_FLAGS -DCMARK_STATIC_DEFINE
    POSITION_INDEPENDENT_CODE ON)

  if (MSVC)
    set_target_properties(${STATICLIBRARY} PROPERTIES
      OUTPUT_NAME "cmark-gfm_static"
      VERSION ${PROJECT_VERSION})
  else()
    set_target_properties(${STATICLIBRARY} PROPERTIES
      OUTPUT_NAME "cmark-gfm"
      VERSION ${PROJECT_VERSION})
  endif(MSVC)

  if (NOT CMARK_SHARED)
    generate_export_header(${STATICLIBRARY}
      BASE_NAME ${PROJECT_NAME})
  endif()

  list(APPEND CMARK_INSTALL ${STATICLIBRARY})
endif()

if (MSVC)
  set_property(TARGET ${PROGRAM}
    APPEND PROPERTY LINK_FLAGS /INCREMENTAL:NO)
endif(MSVC)

if(NOT MSVC OR CMAKE_HOST_SYSTEM_NAME STREQUAL Windows)
  set(CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS_NO_WARNINGS ON)
  include(InstallRequiredSystemLibraries)
endif()

set(libdir lib${LIB_SUFFIX})

install(TARGETS ${PROGRAM} ${CMARK_INSTALL}
  EXPORT cmark-gfm
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION ${libdir}
  ARCHIVE DESTINATION ${libdir}
  )

if(CMARK_SHARED OR CMARK_STATIC)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libcmark-gfm.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/libcmark-gfm.pc @ONLY)
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libcmark-gfm.pc
    DESTINATION ${libdir}/pkgconfig)

  install(FILES
    cmark-gfm.h
    cmark-gfm-extension_api.h
    ${CMAKE_CURRENT_BINARY_DIR}/cmark-gfm_export.h
    ${CMAKE_CURRENT_BINARY_DIR}/cmark-gfm_version.h
    DESTINATION include
    )

  install(EXPORT cmark-gfm DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake)
endif()

# Feature tests
include(CheckIncludeFile)
include(CheckCSourceCompiles)
include(CheckCSourceRuns)
include(CheckSymbolExists)
CHECK_INCLUDE_FILE(stdbool.h HAVE_STDBOOL_H)
CHECK_C_SOURCE_COMPILES(
  "int main() { __builtin_expect(0,0); return 0; }"
  HAVE___BUILTIN_EXPECT)
CHECK_C_SOURCE_COMPILES("
  int f(void) __attribute__ (());
  int main() { return 0; }
" HAVE___ATTRIBUTE__)

CONFIGURE_FILE(
  ${CMAKE_CURRENT_SOURCE_DIR}/config.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/config.h)

# Always compile with warnings
if(MSVC)
  # Force to always compile with W4
  if(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
    string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_C_FLAGS "${CMAKE_C_FLAGS}")
  else()
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /W4")
  endif()
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /WX /wd4706 /wd4204 /wd4221 /wd4100 /D_CRT_SECURE_NO_WARNINGS")
elseif(CMAKE_COMPILER_IS_GNUCC OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Wno-unused-parameter -std=c99 -pedantic")
endif()

# Compile as C++ under MSVC older than 12.0
if(MSVC AND MSVC_VERSION LESS 1800)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /TP")
endif()

if(CMAKE_BUILD_TYPE STREQUAL "Ubsan")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=undefined")
endif()

if(CMARK_LIB_FUZZER)
  set(FUZZ_HARNESS "cmark-fuzz")
  add_executable(${FUZZ_HARNESS} ../test/cmark-fuzz.c ${LIBRARY_SOURCES})
  target_link_libraries(${FUZZ_HARNESS} "${CMAKE_LIB_FUZZER_PATH}")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize-coverage=trace-pc-guard")

  # cmark is written in C but the libFuzzer runtime is written in C++ which
  # needs to link against the C++ runtime. Explicitly link it into cmark-fuzz
  set_target_properties(${FUZZ_HARNESS} PROPERTIES LINK_FLAGS "-lstdc++")
endif()

=== test/CMakeLists.txt ===
# To get verbose output: cmake --build build --target "test" -- ARGS='-V'

# By default, we run the spec tests only if python3 is available.
# To require the spec tests, compile with -DSPEC_TESTS=1

if (SPEC_TESTS)
  find_package(PythonInterp 3 REQUIRED)
else(SPEC_TESTS)
  find_package(PythonInterp 3)
endif(SPEC_TESTS)

if (CMARK_SHARED OR CMARK_STATIC)
  add_test(NAME api_test COMMAND api_test)
endif()

if (WIN32)
  file(TO_NATIVE_PATH ${CMAKE_BINARY_DIR}/src WIN_SRC_DLL_DIR)
  file(TO_NATIVE_PATH ${CMAKE_BINARY_DIR}/extensions WIN_EXTENSIONS_DLL_DIR)
  set(NEWPATH "${WIN_SRC_DLL_DIR};${WIN_EXTENSIONS_DLL_DIR};$ENV{PATH}")
  string(REPLACE ";" "\\;" NEWPATH "${NEWPATH}")
  set_tests_properties(api_test PROPERTIES ENVIRONMENT "PATH=${NEWPATH}")
  set(ROUNDTRIP "${CMAKE_CURRENT_SOURCE_DIR}/roundtrip.bat")
else(WIN32)
  set(ROUNDTRIP "${CMAKE_CURRENT_SOURCE_DIR}/roundtrip.sh")
endif(WIN32)

IF (PYTHONINTERP_FOUND)

  add_test(html_normalization
    ${PYTHON_EXECUTABLE} "-m" "doctest"
    "${CMAKE_CURRENT_SOURCE_DIR}/normalize.py"
    )

  if (CMARK_SHARED)
    add_test(spectest_library
      ${PYTHON_EXECUTABLE} "${CMAKE_CURRENT_SOURCE_DIR}/spec_tests.py" "--no-normalize" "--spec"
      "${CMAKE_CURRENT_SOURCE_DIR}/spec.txt" "--library-dir" "${CMAKE_CURRENT_BINARY_DIR}/../src"
      )

    add_test(pathological_tests_library
      ${PYTHON_EXECUTABLE} "${CMAKE_CURRENT_SOURCE_DIR}/pathological_tests.py"
      "--library-dir" "${CMAKE_CURRENT_BINARY_DIR}/../src"
      )

    add_test(roundtriptest_library
      ${PYTHON_EXECUTABLE}
      "${CMAKE_CURRENT_SOURCE_DIR}/roundtrip_tests.py"
      "--spec" "${CMAKE_CURRENT_SOURCE_DIR}/spec.txt"
      "--library-dir" "${CMAKE_CURRENT_BINARY_DIR}/../src"
      )

    add_test(entity_library
      ${PYTHON_EXECUTABLE}
      "${CMAKE_CURRENT_SOURCE_DIR}/entity_tests.py"
      "--library-dir" "${CMAKE_CURRENT_BINARY_DIR}/../src"
      )
  endif()

  add_test(spectest_executable
    ${PYTHON_EXECUTABLE} "${CMAKE_CURRENT_SOURCE_DIR}/spec_tests.py" "--no-normalize" "--spec" "${CMAKE_CURRENT_SOURCE_DIR}/spec.txt" "--program" "${CMAKE_CURRENT_BINARY_DIR}/../src/cmark-gfm"
    )

  add_test(smartpuncttest_executable
    ${PYTHON_EXECUTABLE} "${CMAKE_CURRENT_SOURCE_DIR}/spec_tests.py" "--no-normalize" "--spec" "${CMAKE_CURRENT_SOURCE_DIR}/smart_punct.txt" "--program" "${CMAKE_CURRENT_BINARY_DIR}/../src/cmark-gfm --smart"
    )

  add_test(extensions_executable
    ${PYTHON_EXECUTABLE}
    "${CMAKE_CURRENT_SOURCE_DIR}/spec_tests.py"
    "--no-normalize"
    "--spec" "${CMAKE_CURRENT_SOURCE_DIR}/extensions.txt"
    "--program" "${CMAKE_CURRENT_BINARY_DIR}/../src/cmark-gfm"
    "--extensions" "table strikethrough autolink tagfilter footnotes"
    )

  add_test(roundtrip_extensions_executable
    ${PYTHON_EXECUTABLE}
    "${CMAKE_CURRENT_SOURCE_DIR}/roundtrip_tests.py"
    "--spec" "${CMAKE_CURRENT_SOURCE_DIR}/extensions.txt"
    "--program" "${CMAKE_CURRENT_BINARY_DIR}/../src/cmark-gfm"
    "--extensions" "table strikethrough autolink tagfilter footnotes"
    )

  add_test(option_table_prefer_style_attributes
    ${PYTHON_EXECUTABLE}
    "${CMAKE_CURRENT_SOURCE_DIR}/roundtrip_tests.py"
    "--spec" "${CMAKE_CURRENT_SOURCE_DIR}/extensions-table-prefer-style-attributes.txt"
    "--program" "${CMAKE_CURRENT_BINARY_DIR}/../src/cmark-gfm --table-prefer-style-attributes"
    "--extensions" "table strikethrough autolink tagfilter footnotes"
    )

  add_test(option_full_info_string
    ${PYTHON_EXECUTABLE}
    "${CMAKE_CURRENT_SOURCE_DIR}/roundtrip_tests.py"
    "--spec" "${CMAKE_CURRENT_SOURCE_DIR}/extensions-full-info-string.txt"
    "--program" "${CMAKE_CURRENT_BINARY_DIR}/../src/cmark-gfm --full-info-string"
    )

  add_test(regressiontest_executable
    ${PYTHON_EXECUTABLE}
    "${CMAKE_CURRENT_SOURCE_DIR}/spec_tests.py" "--no-normalize" "--spec"
    "${CMAKE_CURRENT_SOURCE_DIR}/regression.txt" "--program"
    "${CMAKE_CURRENT_BINARY_DIR}/../src/cmark-gfm"
    )


ELSE(PYTHONINTERP_FOUND)

  message("\n*** A python 3 interpreter is required to run the spec tests.\n")
  add_test(skipping_spectests
    echo "Skipping spec tests, because no python 3 interpreter is available.")

ENDIF(PYTHONINTERP_FOUND)

=== debian/changelog ===
cmark-gfm (0.28.3.gfm.19-3) unstable; urgency=medium

  * Add library dependencies to -dev packages

 -- Keith Packard <keithp@keithp.com>  Tue, 23 Oct 2018 09:50:25 -0700

cmark-gfm (0.28.3.gfm.19-2) unstable; urgency=medium

  * Add @builddeps@ to tests/control

 -- Keith Packard <keithp@keithp.com>  Mon, 22 Oct 2018 18:14:55 -0700

cmark-gfm (0.28.3.gfm.19-1) unstable; urgency=medium

  * Upstream version 0.28.3.gfm.19

 -- Keith Packard <keithp@keithp.com>  Mon, 22 Oct 2018 13:18:32 -0700

=== debian/control ===
--- 
+++ 
@@ -31,7 +31,7 @@
 Package: libcmark-gfm-dev
 Architecture: any
 Section: libdevel
-Depends: ${misc:Depends}
+Depends: ${misc:Depends}, libcmark-gfm0 (= ${binary:Version})
 Description: CommonMark GitHub flavor gfm library dev files
  cmark-gfm is the GitHub flavor of the cmark C reference
  implementation of CommonMark, a rationalized version of Markdown
@@ -51,10 +51,9 @@
 Package: libcmark-gfm-extensions-dev
 Architecture: any
 Section: libdevel
-Depends: ${misc:Depends}
+Depends: ${misc:Depends}, libcmark-gfm-extensions0 (= ${binary:Version})
 Description: CommonMark GitHub flavor gfm extensions library dev files
  cmark-gfm is the GitHub flavor of the cmark C reference
  implementation of CommonMark, a rationalized version of Markdown
  syntax with a spec. This package provides the development files for
  the gfm extensions library
-

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_MULTIARCH?=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEB_CMAKE_EXTRA_FLAGS=\
	-DCMAKE_INSTALL_LIBDIR="/usr/lib/$(DEB_HOST_MULTIARCH)" \
	-DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)"

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CMAKE_EXTRA_FLAGS)

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%cmark-$1.tar.gz%" \
    https://github.com/github/cmark/releases \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## cmark-gfm 0.28.3.gfm.20

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,7 @@
 set(PROJECT_VERSION_MAJOR 0)
 set(PROJECT_VERSION_MINOR 28)
 set(PROJECT_VERSION_PATCH 3)
-set(PROJECT_VERSION_GFM 19)
+set(PROJECT_VERSION_GFM 20)
 set(PROJECT_VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}.gfm.${PROJECT_VERSION_GFM} )
 
 option(CMARK_TESTS "Build cmark-gfm tests and enable testing" ON)

=== debian/changelog ===
cmark-gfm (0.28.3.gfm.20-3) unstable; urgency=medium

  * Mark libraries as Multi-Arch: same

 -- Keith Packard <keithp@keithp.com>  Sat, 09 Mar 2019 19:23:07 +0100

cmark-gfm (0.28.3.gfm.20-2) unstable; urgency=medium

  * Change debian/watch to monitor git tags instead of tar.gz files

 -- Keith Packard <keithp@keithp.com>  Sat, 09 Mar 2019 17:00:52 +0100

cmark-gfm (0.28.3.gfm.20-1) unstable; urgency=medium

  * Upstream version 0.28.3.gfm.20
  * Mark library dependency bug closed. (Closes: #911049)
  * Add LFS support.

 -- Keith Packard <keithp@keithp.com>  Sat, 09 Mar 2019 11:29:52 +0100

=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,11 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 DEB_HOST_MULTIARCH?=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+
+# cmark-gfm uses many asserts which cause absolute paths
+# to be written to the object files. We'll smash the __FILE__
+# value here to avoid this
+CFLAGS += -D__FILE__='"cmark-gfm"'
 
 DEB_CMAKE_EXTRA_FLAGS=\
 	-DCMAKE_INSTALL_LIBDIR="/usr/lib/$(DEB_HOST_MULTIARCH)" \

=== debian/watch ===
version=4
opts="mode=git, gitmode=full, pgpmode=none" \
https://github.com/github/cmark-gfm \
refs/tags/([\d\.]+) debian uupdate

## cmark-gfm 0.29.0.gfm.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(cmark-gfm)

set(PROJECT_VERSION_MAJOR 0)
set(PROJECT_VERSION_MINOR 29)
set(PROJECT_VERSION_PATCH 0)
set(PROJECT_VERSION_GFM 0)
set(PROJECT_VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}.gfm.${PROJECT_VERSION_GFM})

include("FindAsan.cmake")
include("CheckFileOffsetBits.cmake")

if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
    message(FATAL_ERROR "Do not build in-source.\nPlease remove CMakeCache.txt and the CMakeFiles/ directory.\nThen: mkdir build ; cd build ; cmake .. ; make")
endif()

option(CMARK_TESTS "Build cmark-gfm tests and enable testing" ON)
option(CMARK_STATIC "Build static libcmark-gfm library" ON)
option(CMARK_SHARED "Build shared libcmark-gfm library" ON)
option(CMARK_LIB_FUZZER "Build libFuzzer fuzzing harness" OFF)

add_subdirectory(src)
add_subdirectory(extensions)
if(CMARK_TESTS AND (CMARK_SHARED OR CMARK_STATIC))
  add_subdirectory(api_test)
endif()
add_subdirectory(man)
if(CMARK_TESTS)
  enable_testing()
  add_subdirectory(test testdir)
endif()

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING
  "Choose the type of build, options are: Debug Profile Release Asan Ubsan." FORCE)
endif(NOT CMAKE_BUILD_TYPE)

=== Makefile ===
--- 
+++ 
@@ -75,7 +75,7 @@
 afl:
 	@[ -n "$(AFL_PATH)" ] || { echo '$$AFL_PATH not set'; false; }
 	mkdir -p $(BUILDDIR)
-	cd $(BUILDDIR) && cmake .. -DCMAKE_C_COMPILER=$(AFL_PATH)/afl-clang
+	cd $(BUILDDIR) && cmake .. -DCMARK_TESTS=0 -DCMAKE_C_COMPILER=$(AFL_PATH)/afl-clang
 	$(MAKE)
 	$(AFL_PATH)/afl-fuzz \
 	    -i test/afl_test_cases \

=== extensions/CMakeLists.txt ===
--- 
+++ 
@@ -10,6 +10,7 @@
     ext_scanners.c
     ext_scanners.re
     ext_scanners.h
+    tasklist.c
    )
 
 include_directories(

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -74,8 +74,10 @@
 
 include (GenerateExportHeader)
 
+include("../CheckFileOffsetBits.cmake")
+CHECK_FILE_OFFSET_BITS()
+
 add_executable(${PROGRAM} ${PROGRAM_SOURCES})
-add_compiler_export_flags()
 
 if(CMARK_SHARED)
   target_link_libraries(${PROGRAM} libcmark-gfm-extensions libcmark-gfm)
@@ -94,14 +96,9 @@
 set(CMAKE_C_FLAGS_PROFILE "${CMAKE_C_FLAGS_RELEASE} -pg")
 set(CMAKE_LINKER_PROFILE "${CMAKE_LINKER_FLAGS_RELEASE} -pg")
 
-add_definitions(-DLIBDIR=\"${CMAKE_BINARY_DIR}\")
-
-if (${CMAKE_VERSION} VERSION_GREATER "1.8")
-  set(CMAKE_C_VISIBILITY_PRESET hidden)
-  set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)
-elseif(CMAKE_COMPILER_IS_GNUCC OR ${CMAKE_C_COMPILER_ID} STREQUAL "Clang")
-  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")
-endif ()
+# -fvisibility=hidden
+set(CMAKE_C_VISIBILITY_PRESET hidden)
+set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)
 
 if (CMARK_SHARED)
   add_library(${LIBRARY} SHARED ${LIBRARY_SOURCES})

=== debian/changelog ===
cmark-gfm (0.29.0.gfm.0-4) unstable; urgency=medium

  * Add patch to make tests compatible with Python 3.8

 -- Keith Packard <keithp@keithp.com>  Mon, 09 Mar 2020 13:16:13 -0700

cmark-gfm (0.29.0.gfm.0-3) unstable; urgency=medium

  * Add patch increasing pathological test limit to 10s for sparc64

 -- Keith Packard <keithp@keithp.com>  Tue, 17 Dec 2019 13:33:53 -0800

cmark-gfm (0.29.0.gfm.0-2) unstable; urgency=medium

  * Merge upstream fix for tasklist on MSB machines (Closes: #944652)

 -- Keith Packard <keithp@keithp.com>  Mon, 16 Dec 2019 20:37:41 -0800

cmark-gfm (0.29.0.gfm.0-1) unstable; urgency=medium

  * Upstream version 0.29.0.gfm.0
  * Change 'debian/watch' to look for upstream tags including 'gfm'
  * Replace large file support for 32-bit builds with upstream version

 -- Keith Packard <keithp@keithp.com>  Mon, 22 Apr 2019 11:26:50 -0700

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,9 @@
 Priority: optional
 Homepage: https://github.com/github/cmark
 Maintainer: Keith Packard <keithp@keithp.com>
-Build-Depends: debhelper (>= 11), cmake, python3
-Standards-Version: 4.2.1
+Build-Depends: debhelper-compat (= 12), cmake, python3
+Rules-Requires-Root: no
+Standards-Version: 4.5.0
 
 Package: cmark-gfm
 Architecture: any
@@ -21,6 +22,7 @@
 Package: libcmark-gfm0
 Architecture: any
 Section: libs
+Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: CommonMark GitHub flavor gfm library
  cmark-gfm is the GitHub flavor of the cmark C reference
@@ -31,6 +33,7 @@
 Package: libcmark-gfm-dev
 Architecture: any
 Section: libdevel
+Multi-Arch: same
 Depends: ${misc:Depends}, libcmark-gfm0 (= ${binary:Version})
 Description: CommonMark GitHub flavor gfm library dev files
  cmark-gfm is the GitHub flavor of the cmark C reference
@@ -41,6 +44,7 @@
 Package: libcmark-gfm-extensions0
 Architecture: any
 Section: libs
+Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: CommonMark GitHub flavor gfm extension library
  cmark-gfm is the GitHub flavor of the cmark C reference
@@ -51,6 +55,7 @@
 Package: libcmark-gfm-extensions-dev
 Architecture: any
 Section: libdevel
+Multi-Arch: same
 Depends: ${misc:Depends}, libcmark-gfm-extensions0 (= ${binary:Version})
 Description: CommonMark GitHub flavor gfm extensions library dev files
  cmark-gfm is the GitHub flavor of the cmark C reference

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = reproducible=+fixfilepath hardening=+all

DEB_HOST_MULTIARCH?=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEB_CMAKE_EXTRA_FLAGS=\
	-DCMAKE_INSTALL_LIBDIR="/usr/lib/$(DEB_HOST_MULTIARCH)" \
	-DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)"

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CMAKE_EXTRA_FLAGS)

## cmark-gfm 0.29.0.gfm.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 set(PROJECT_VERSION_MAJOR 0)
 set(PROJECT_VERSION_MINOR 29)
 set(PROJECT_VERSION_PATCH 0)
-set(PROJECT_VERSION_GFM 0)
+set(PROJECT_VERSION_GFM 2)
 set(PROJECT_VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}.gfm.${PROJECT_VERSION_GFM})
 
 include("FindAsan.cmake")

=== debian/changelog ===
cmark-gfm (0.29.0.gfm.2-1+really.0.29.0.gfm.0ubuntu1) jammy; urgency=medium

  * Revert to 0.29.0.gfm.0-6 for Jammy. (LP: #1958235)
    The new version, 0.29.0.gfm.2-1, is a SONAME bump
    and causes a regression in pandoc, pandoc-citeproc,
    patat, gitit, blogliterately, at least. Therefore,
    revert to the older version until this is fixed in
    Debian and then we can have this sync'd here again.
    (LP: #1958235)

 -- Utkarsh Gupta <utkarsh@ubuntu.com>  Wed, 19 Jan 2022 05:38:01 +0530

cmark-gfm (0.29.0.gfm.2-1) unstable; urgency=medium

  * New upstream version.
  * Fix for CVE-2020-5238. (Closes: #965984)
  * Switch man page --safe to --unsafe. (Closes: #1003745)

 -- Keith Packard <keithp@keithp.com>  Mon, 17 Jan 2022 16:43:27 -0800

cmark-gfm (0.29.0.gfm.0-6) unstable; urgency=medium

  * Use <stdbool.h> directly instead of "config.h". (Closes: #969212)

 -- Keith Packard <keithp@keithp.com>  Wed, 02 Sep 2020 10:25:33 -0700

cmark-gfm (0.29.0.gfm.0-5) unstable; urgency=medium

  * Install header files in -dev packages. (Closes: #968709)
  * Fix .symbols files for new upstream version.
  * Install libcmark-gfm.pc in arch directory

 -- Keith Packard <keithp@keithp.com>  Fri, 28 Aug 2020 10:24:17 -0700

## cmark-gfm 0.29.0.gfm.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 set(PROJECT_VERSION_MAJOR 0)
 set(PROJECT_VERSION_MINOR 29)
 set(PROJECT_VERSION_PATCH 0)
-set(PROJECT_VERSION_GFM 2)
+set(PROJECT_VERSION_GFM 3)
 set(PROJECT_VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}.gfm.${PROJECT_VERSION_GFM})
 
 include("FindAsan.cmake")

=== debian/changelog ===
cmark-gfm (0.29.0.gfm.3-3) unstable; urgency=medium

  * Need to upload orig source

 -- Keith Packard <keithp@keithp.com>  Fri, 11 Mar 2022 12:10:24 -0800

cmark-gfm (0.29.0.gfm.3-2) unstable; urgency=medium

  * Need to upload binary version

 -- Keith Packard <keithp@keithp.com>  Fri, 11 Mar 2022 11:15:14 -0800

cmark-gfm (0.29.0.gfm.3-1) unstable; urgency=medium

  * New upstream version.
  * Fix for CVE-2022-24724. (Closes: #1006756)

 -- Keith Packard <keithp@keithp.com>  Fri, 11 Mar 2022 10:39:54 -0800

cmark-gfm (0.29.0.gfm.2-2) unstable; urgency=medium

  * Generate library package names from cmark-gfm upstream
    version. (Closes: #1003964)

 -- Keith Packard <keithp@keithp.com>  Wed, 19 Jan 2022 16:03:13 -0800

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Priority: optional
 Homepage: https://github.com/github/cmark
 Maintainer: Keith Packard <keithp@keithp.com>
-Build-Depends: debhelper-compat (= 12), cmake, python3
+Build-Depends: debhelper-compat (= 13), cmake, python3
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0.1
 
 Package: cmark-gfm
 Architecture: any
@@ -19,10 +19,12 @@
  This GitHub flavored version has extensions for org-mode style
  tables, auto-linking, and more.
 
-Package: libcmark-gfm0
+Package: libcmark-gfm0.29.0.gfm.3
 Architecture: any
 Section: libs
 Multi-Arch: same
+Replaces: libcmark-gfm0 (>= ${source:Upstream-Version})
+Breaks: libcmark-gfm0 (>= ${source:Upstream-Version})
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: CommonMark GitHub flavor gfm library
  cmark-gfm is the GitHub flavor of the cmark C reference
@@ -34,17 +36,19 @@
 Architecture: any
 Section: libdevel
 Multi-Arch: same
-Depends: ${misc:Depends}, libcmark-gfm0 (= ${binary:Version})
+Depends: ${misc:Depends}, libcmark-gfm0.29.0.gfm.3 (= ${binary:Version})
 Description: CommonMark GitHub flavor gfm library dev files
  cmark-gfm is the GitHub flavor of the cmark C reference
  implementation of CommonMark, a rationalized version of Markdown
  syntax with a spec. This package provides the development files for
  the gfm library
 
-Package: libcmark-gfm-extensions0
+Package: libcmark-gfm-extensions0.29.0.gfm.3
 Architecture: any
 Section: libs
 Multi-Arch: same
+Replaces: libcmark-gfm-extensions0 (>= ${source:Upstream-Version})
+Breaks: libcmark-gfm-extensions0 (>= ${source:Upstream-Version})
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: CommonMark GitHub flavor gfm extension library
  cmark-gfm is the GitHub flavor of the cmark C reference
@@ -56,7 +60,7 @@
 Architecture: any
 Section: libdevel
 Multi-Arch: same
-Depends: ${misc:Depends}, libcmark-gfm-extensions0 (= ${binary:Version})
+Depends: ${misc:Depends}, libcmark-gfm-extensions0.29.0.gfm.3 (= ${binary:Version})
 Description: CommonMark GitHub flavor gfm extensions library dev files
  cmark-gfm is the GitHub flavor of the cmark C reference
  implementation of CommonMark, a rationalized version of Markdown

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = reproducible=+fixfilepath hardening=+all

DEB_HOST_MULTIARCH?=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEB_CMAKE_EXTRA_FLAGS=\
	-DCMAKE_INSTALL_LIBDIR="/usr/lib/$(DEB_HOST_MULTIARCH)" \
	-DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
	-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON 

%:
	dh $@ --buildsystem=cmake

clean: debian/control

override_dh_auto_configure:
	dh_auto_configure -- $(DEB_CMAKE_EXTRA_FLAGS)

debian/control: debian/control-in
	sed 's/%DEB_VERSION_UPSTREAM%/$(DEB_VERSION_UPSTREAM)/g' $< > $@
	echo 'usr/lib/*/libcmark-gfm.so.*' > debian/libcmark-gfm$(DEB_VERSION_UPSTREAM).install
	echo 'usr/lib/*/libcmark-gfm-extensions.so.*' > debian/libcmark-gfm-extensions$(DEB_VERSION_UPSTREAM).install

## cmark-gfm 0.29.0.gfm.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 set(PROJECT_VERSION_MAJOR 0)
 set(PROJECT_VERSION_MINOR 29)
 set(PROJECT_VERSION_PATCH 0)
-set(PROJECT_VERSION_GFM 3)
+set(PROJECT_VERSION_GFM 6)
 set(PROJECT_VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}.gfm.${PROJECT_VERSION_GFM})
 
 include("FindAsan.cmake")

=== extensions/CMakeLists.txt ===
--- 
+++ 
@@ -52,7 +52,7 @@
   add_library(${STATICLIBRARY} STATIC ${LIBRARY_SOURCES})
 
   set_target_properties(${STATICLIBRARY} PROPERTIES
-    COMPILE_FLAGS "-DCMARK_STATIC_DEFINE -DCMARKEXTENSIONS_STATIC_DEFINE"
+    COMPILE_FLAGS "-DCMARK_GFM_STATIC_DEFINE -DCMARK_GFM_EXTENSIONS_STATIC_DEFINE"
     POSITION_INDEPENDENT_CODE ON)
 
   if (MSVC)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -60,9 +60,7 @@
   )
 
 set(PROGRAM "cmark-gfm")
-set(PROGRAM_SOURCES
-  main.c
-  )
+set(PROGRAM_SOURCES main.c)
 
 include_directories(. ${CMAKE_CURRENT_BINARY_DIR})
 include_directories(
@@ -87,7 +85,7 @@
 
 # Disable the PUBLIC declarations when compiling the executable:
 set_target_properties(${PROGRAM} PROPERTIES
-  COMPILE_FLAGS "-DCMARK_STATIC_DEFINE -DCMARKEXTENSIONS_STATIC_DEFINE")
+  COMPILE_FLAGS "-DCMARK_GFM_STATIC_DEFINE -DCMARK_GFM_EXTENSIONS_STATIC_DEFINE")
 
 # Check integrity of node structure when compiled as debug:
 set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -DCMARK_DEBUG_NODES -DDEBUG")
@@ -123,7 +121,7 @@
 if (CMARK_STATIC)
   add_library(${STATICLIBRARY} STATIC ${LIBRARY_SOURCES})
   set_target_properties(${STATICLIBRARY} PROPERTIES
-    COMPILE_FLAGS -DCMARK_STATIC_DEFINE
+    COMPILE_FLAGS -DCMARK_GFM_STATIC_DEFINE
     POSITION_INDEPENDENT_CODE ON)
 
   if (MSVC)

=== debian/changelog ===
cmark-gfm (0.29.0.gfm.6-6) unstable; urgency=medium

  * Another attempt to get spec.html to be created by buildd

 -- Keith Packard <keithp@keithp.com>  Wed, 28 Dec 2022 22:21:05 -0800

cmark-gfm (0.29.0.gfm.6-5) unstable; urgency=medium

  * Merge in patch from NMU 0.29.0.gfm.6-2.1

 -- Keith Packard <keithp@keithp.com>  Wed, 28 Dec 2022 21:38:59 -0800

cmark-gfm (0.29.0.gfm.6-4) unstable; urgency=medium

  * Add install depend on spec.html to get that built at the right time

 -- Keith Packard <keithp@keithp.com>  Wed, 28 Dec 2022 21:31:22 -0800

cmark-gfm (0.29.0.gfm.6-3) unstable; urgency=medium

  * Set cmark-gfm to Multi-Arch: foriegn. (Closes: #1027152)
  * Install config.h with libcmark-gfm-dev. (Closes: #1022183)
  * Install spec (both .txt and .html). (Closes: #1023350)

 -- Keith Packard <keithp@keithp.com>  Wed, 28 Dec 2022 13:41:28 -0800

cmark-gfm (0.29.0.gfm.6-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Apply patch to fix FTBFS on s390x (Closes: #1023020)

 -- Scott Talbert <swt@techie.net>  Wed, 30 Nov 2022 10:41:13 -0500

cmark-gfm (0.29.0.gfm.6-2) unstable; urgency=medium

  * Binary version because the library always changes package
    names.
  * New upstream includes fix for CVE-2022-39209. (Closes: #1020588)
  
 -- Keith Packard <keithp@keithp.com>  Tue, 25 Oct 2022 23:24:33 -0700

cmark-gfm (0.29.0.gfm.6-1) unstable; urgency=medium

  * New upstream version.
  * Install all headers in /usr/include/cmark-gfm. (Closes: #1022183)

 -- Keith Packard <keithp@keithp.com>  Tue, 25 Oct 2022 22:38:21 -0700

=== debian/control ===
--- 
+++ 
@@ -9,6 +9,7 @@
 
 Package: cmark-gfm
 Architecture: any
+Multi-Arch: foreign
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: CommonMark parsing and rendering program, GitHub flavor
  cmark-gfm is the GitHub flavor of the cmark C reference
@@ -19,7 +20,7 @@
  This GitHub flavored version has extensions for org-mode style
  tables, auto-linking, and more.
 
-Package: libcmark-gfm0.29.0.gfm.3
+Package: libcmark-gfm0.29.0.gfm.6
 Architecture: any
 Section: libs
 Multi-Arch: same
@@ -36,14 +37,14 @@
 Architecture: any
 Section: libdevel
 Multi-Arch: same
-Depends: ${misc:Depends}, libcmark-gfm0.29.0.gfm.3 (= ${binary:Version})
+Depends: ${misc:Depends}, libcmark-gfm0.29.0.gfm.6 (= ${binary:Version})
 Description: CommonMark GitHub flavor gfm library dev files
  cmark-gfm is the GitHub flavor of the cmark C reference
  implementation of CommonMark, a rationalized version of Markdown
  syntax with a spec. This package provides the development files for
  the gfm library
 
-Package: libcmark-gfm-extensions0.29.0.gfm.3
+Package: libcmark-gfm-extensions0.29.0.gfm.6
 Architecture: any
 Section: libs
 Multi-Arch: same
@@ -60,7 +61,7 @@
 Architecture: any
 Section: libdevel
 Multi-Arch: same
-Depends: ${misc:Depends}, libcmark-gfm-extensions0.29.0.gfm.3 (= ${binary:Version})
+Depends: ${misc:Depends}, libcmark-gfm-extensions0.29.0.gfm.6 (= ${binary:Version})
 Description: CommonMark GitHub flavor gfm extensions library dev files
  cmark-gfm is the GitHub flavor of the cmark C reference
  implementation of CommonMark, a rationalized version of Markdown

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,7 @@
 DEB_CMAKE_EXTRA_FLAGS=\
 	-DCMAKE_INSTALL_LIBDIR="/usr/lib/$(DEB_HOST_MULTIARCH)" \
 	-DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
-	-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON 
+	-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON
 
 %:
 	dh $@ --buildsystem=cmake
@@ -23,3 +23,7 @@
 	sed 's/%DEB_VERSION_UPSTREAM%/$(DEB_VERSION_UPSTREAM)/g' $< > $@
 	echo 'usr/lib/*/libcmark-gfm.so.*' > debian/libcmark-gfm$(DEB_VERSION_UPSTREAM).install
 	echo 'usr/lib/*/libcmark-gfm-extensions.so.*' > debian/libcmark-gfm-extensions$(DEB_VERSION_UPSTREAM).install
+
+override_dh_auto_install:
+	dh_auto_install
+	*/src/cmark-gfm test/spec.txt > debian/tmp/spec.html
